#
# ¤Ѥꤹ
# Copyright (c) 2002-2004 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: $
#

package Random;

#----------------------------------------------------------------------#
# ˶ᤤ
# : κ
sub rand2($) {
	my($limit) = @_;
	$count = 0 unless (defined $count);
	if ($count == 100) {
		$count = 0;
		srand unpack("C", getc(RAND));
	} else {
		$count++;
	}
	return rand $limit;
}

#----------------------------------------------------------------------#
# եŤΤͥ褷ƥ¤Ѥ
# : νŤ, оݤ
sub sort($@) {
	my($wait, @files) = @_;
	my %point = ();
	@files = randomize(@files);
	foreach (@files) {
		$point{$_} = (-A $_) + rand $wait;
	}
	return sort {$point{$b} <=> $point{$a}} @files;
}

#----------------------------------------------------------------------#
# ¤Ѥ
# : оݤ
sub randomize(@) {
	my(@list) = @_;
	my($i);
	for ($i=@list; $i>0; $i--) {
		my $t = int rand $i;
		($list[$i-1], $list[$t]) = ($list[$t], $list[$i-1]);
	}
	return @list;
}

1;
